// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlBoldingLabel")]
    pub struct BoldingLabel(Object<ffi::DzlBoldingLabel, ffi::DzlBoldingLabelClass>) @extends gtk::Label, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_bolding_label_get_type(),
    }
}

impl BoldingLabel {
    #[doc(alias = "dzl_bolding_label_new")]
    pub fn new(str: &str, bold: bool) -> BoldingLabel {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_none(ffi::dzl_bolding_label_new(
                str.to_glib_none().0,
                bold.into_glib(),
            ))
        }
    }

    #[doc(alias = "dzl_bolding_label_new_with_mnemonic")]
    #[doc(alias = "new_with_mnemonic")]
    pub fn with_mnemonic(str: &str, bold: bool) -> BoldingLabel {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_none(ffi::dzl_bolding_label_new_with_mnemonic(
                str.to_glib_none().0,
                bold.into_glib(),
            ))
        }
    }

    #[doc(alias = "dzl_bolding_label_set_bold")]
    pub fn set_bold(&self, bold: bool) {
        unsafe {
            ffi::dzl_bolding_label_set_bold(self.to_glib_none().0, bold.into_glib());
        }
    }

    #[doc(alias = "dzl_bolding_label_set_weight")]
    pub fn set_weight(&self, weight: pango::Weight) {
        unsafe {
            ffi::dzl_bolding_label_set_weight(self.to_glib_none().0, weight.into_glib());
        }
    }

    #[doc(alias = "bold")]
    pub fn connect_bold_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_bold_trampoline<F: Fn(&BoldingLabel) + 'static>(
            this: *mut ffi::DzlBoldingLabel,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::bold\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_bold_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl fmt::Display for BoldingLabel {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("BoldingLabel")
    }
}
